## palo 1.0

=== Makefile ===
# Native PARISC/Linux Project Bootstrap Code
#
# Copyright (C) 2000 Hewlett Packard (Paul Bame, bame@puffin.external.hp.com)
# Copyright (C) 1999 Jason Eckhardt <jle@cygnus.com>
#                    Helge Deller <deller@gmx.de>
#                    Christopher Beard <cjbeard@thepuffingroup.com>
#                    Alex deVries <adevries@thepuffingroup.com>
#

# This is here temporarily for folks who still have the old linux makefile
ifneq ($(strip ${TOPDIR}),)
    PA=${TOPDIR}
endif

# here is one which should work for nearly everyone, unless they
# have a different name for their linux tree:
ifeq ($(strip ${PA}),)
    PA := $(shell pwd)/../linux
endif

export PA

# Choose at most one of RAMDISK or NFSROOT below
#
# Set RAMDISK to a ramdisk image to in order to load the ramdisk on the
# boot medium and make the default kernel command line to use it
#
# RAMDISK = ${PA}/ramdisk.bin

#
# Set NFSROOT to the IP address of your NFS root server to make
# a kernel command line to use NFS root.  This is incompatible with
# RAMDISK above.  Though you can have both a ramdisk and an NFS root,
# as far as palo is concerned anyway, this Makefile doesn't help you
# do that and I'm not sure the kernel's very good at it right now either.
#
NFSROOT = 10.10.10.2

ROOT=root=/dev/sda1

#
# In case you want to use ISA cards (or any edge triggered EISA cards) in your 
# EISA slots, just uncomment the following line and specify the corresponding 
# irq level(s)
#
# EISAIRQ = eisa_irq_edge=3,4,5,7,9,10,11,14,15


ifneq ($(strip ${RAMDISK}),)
    PALOSTUFF=-r ${RAMDISK}
    ROOT=root=/dev/ram initrd=0/ramdisk
endif

ifneq ($(strip ${NFSROOT}),)
    PALOSTUFF=
    ROOT=root=/dev/nfs nfsroot=${NFSROOT} ip=bootp
endif

CMDLINE = 0/vmlinux HOME=/ TERM=linux $(ROOT) $(EISAIRQ) $(CONSOLE)

all: makepalo README palo.conf
	
README:	README.html
	lynx -dump README.html > README

makepalo:
	cd palo && make

makeipl:
	cd ipl && make

lifimage:	all Makefile lifimage-only

lifimage-only: ${PA}/vmlinux iplboot
	./palo/palo -f /dev/null \
		-b iplboot \
		-k ${PA}/vmlinux \
		${PALOSTUFF} \
		-c "${CMDLINE}" \
		-s lifimage

iplboot:	makeipl makepalo ipl/iplelf
	./palo/mkbootable ipl/iplelf iplboot

clean:
	rm -f lifimage palo.8.gz changelog.gz
	cd ipl && make clean
	cd palo && make clean

realclean:
	rm -f iplboot lifimage palo.8.gz changelog.gz
	cd ipl && make clean
	cd palo && make clean

distclean:
	rm -f lifimage palo.8.gz changelog.gz
	cd ipl && make distclean
	cd palo && make distclean

palo.8.gz:	palo.8
	gzip -9 < palo.8 > palo.8.gz

changelog.gz:	debian/changelog
	gzip -9 < debian/changelog > changelog.gz

INSTALL	=	install
IFLAGS	=	-o root -g root
INSTALL	+=	${IFLAGS}
DESTDIR = ./root

install: all README.html palo.conf palo/palo palo.8.gz changelog.gz
	${INSTALL} -d ${DESTDIR}/usr/share/doc/palo \
			${DESTDIR}/etc ${DESTDIR}/sbin \
			${DESTDIR}/usr/share/palo \
			${DESTDIR}/usr/share/man/man8
	${INSTALL} -m644 palo.conf ${DESTDIR}/usr/share/doc/palo
	${INSTALL} palo/palo ${DESTDIR}/sbin
	@# iplboot isn't natively executable -- don't set mode=x
	${INSTALL} -m444 iplboot ${DESTDIR}/usr/share/palo
	${INSTALL} -m444 README.html README changelog.gz \
			${DESTDIR}/usr/share/doc/palo
	${INSTALL} -m444 palo.8.gz ${DESTDIR}/usr/share/man/man8

=== debian/changelog ===
palo (1.0) unstable; urgency=low

  * package override has been fixed so debian/rules changes should
    now be honored, causing palo to be built on all architectures
    priority optional
  * closes: 140580

 -- Paul Bame <bame@debian.org>  Mon,  1 Apr 2002 09:59:15 -0700

palo (0.99) unstable; urgency=low

  * remove extraneous files from source pkg (Closes: #130365)
  * smarter STI console selection from Fleedwood
  * message tweek from Helge
  * experimental palo_kernel= passed to kernel

 -- Paul Bame <bame@debian.org>  Thu, 24 Jan 2002 10:49:03 -0700

palo (0.98) unstable; urgency=low

  * load ramdisk from ext2 implementation from James Bottomley

 -- Paul Bame <bame@debian.org>  Mon, 31 Dec 2001 12:38:31 -0700

palo (0.97) unstable; urgency=low

  * Fixed lintian complaints
  * Minor makefile tweek
  * Optimize boot device reads for better performance
  * Adopt/adapt aboot-0.9 ext2 code (was from aboot-0.5)
  * Add '-onlcr' to puts() and removed \r from most printfs

 -- Paul Bame <bame@debian.org>  Sun, 18 Nov 2001 20:47:57 -0700

palo (0.96) unstable; urgency=low

  * Many boot message usability improvements.
  * Closes: #113651, #114515, #114614, #115350, #114999, #114145

 -- Paul Bame <bame@debian.org>  Thu,  1 Nov 2001 16:24:24 -0700

palo (0.95) unstable; urgency=low

  * Non-Maintainer Upload
  * increment palo version in lib/common.h
  * Cleanup changelog. Closes: #114999
  * Change arch back to hppa. Closes: #114145
  * Fix dhelp postinstall problem.  Closes: #113651, #114515, #114614, #115350

 -- Matt Taggart <taggart@debian.org>  Tue, 16 Oct 2001 18:34:45 -0600

palo (0.94) unstable; urgency=low

  * Add support for symlinks so we can reference /boot/vmlinux in palo.conf
    and not have to rerun palo on every kernel upgrade.(Richard Hirst)
  * Move iplboot into /usr/share/palo.(Richard Hirst)
  * Only generate iplboot if building on hppa machines.  debian-cd needs
    palo, and is likely to be run on i386.(Richard Hirst)
  * --bootloader now defaults to /usr/share/palo/iplboot so is usually
    not required.  Adjusted documents slightly to accomodate.
  * add postinstall/prerm scripts to handle changed iplboot location

 -- Paul Bame <bame@debian.org>  Sat,  8 Sep 2001 12:32:21 -0600

palo (0.93) unstable; urgency=low

  * Fix boot loader "guess" logic to be smarter on dual-width-capable
    machines when only one kernel is available.
  * Remove a couple of gratuitous printfs
  * Archive link palo.  Not a bad idea otherwise but required because
    dpkg-shlibdeps started whining.  I'm sure I'll get grief for this.

 -- Paul Bame <bame@debian.org>  Wed, 11 Jul 2001 11:00:17 -0600

palo (0.92) unstable; urgency=low

  * Removed SOM loader code
  * If the user hasn't specified one, palo/ipl adds the correct console=
    to the command line based on whether the boot console is full
    (ttyS0, serial) or half (tty0, graphics) duplex.  Also adds sti=
    and sti_font= if they're missing.
  * Palo header version is now 3.  Can store both a 32 and a 64-bit kernel
    in the F0/sequential/CDROM formats.
  * When booting from F0/sequential/CDROM palo guesses the 32/64-ness
    by asking firmware if the user doesn't specify 0/vmlinux64 or 0/vmlinux32.
    On boxes which support both 32 and 64, 32 is chosen.
  * If no TERM= in kernel cmd line, when guessing serial/sti, add TERM=vt102
    for former and TERM=linux for latter
  * Print boot command line even in non-interactive mode
  * Place kernels and ramdisks on 2k boundaries on sequential media to help
    avoid reverse seeks during boot.

 -- Paul Bame <bame@debian.org>  Wed, 20 Jun 2001 10:21:06 -0600

palo (0.91) unstable; urgency=high

  * Fixed check which causes some narrow IPL loads to fail

 -- Paul Bame <bame@debian.org>  Tue, 29 May 2001 11:39:23 -0600

palo (0.90) unstable; urgency=low

  * Added support for calling PDC/IODC in wide mode (i.e., for
    Superdome).  PALO ipl continues to run in narrow mode on all
    platforms, except that PDC/IODC calls are made in the mode ipl was
    started in.

 -- Bjorn Helgaas <bjorn_helgaas@hp.com>  Tue, 15 May 2001 13:17:21 -0600

palo (0.89) unstable; urgency=high

  * Palo can now prepare disks >2G on 32-bit kernels (even though it
    is not using large file I/O calls, which are not useful yet anyway).
    (fixes bugs.parisc-linux.org #125)
   * fixed bugs.parisc-linux.org #89

 -- Paul Bame <bame@debian.org>  Fri, 11 May 2001 19:07:18 -0600

palo (0.88) unstable; urgency=high

  * Fix several lintian bugs by uncommenting 2 lines in debian/rules

 -- Paul Bame <bame@debian.org>  Fri, 11 May 2001 16:07:18 -0600

  * No longer ship /etc/palo.conf as config file -- expect installer
    to provide one now.  Example in /usr/share/doc/palo.  Should have
    some post-install magic to offer to run palo if /etc/palo.conf
    exists, and a complaint if /etc/palo.conf doesn't exist because
    you should have one from running the installer.
  * Changed palo to a native Debian package since it's maintained
    as one.

palo (0.86-1) unstable; urgency=high

  * Probably required to support later non-0xc0100000 kernels

 -- Paul Bame <paul_bame@hp.com>  Wed, 14 Feb 2001 15:22:45 -0700

palo (0.85-1) unstable; urgency=low

  * Initial Release.

 -- Paul Bame <paul_bame@hp.com>  Thu, 18 Jan 2001 18:49:42 -0700

=== debian/control ===
Source: palo
Section: base
Priority: optional
Maintainer: Paul Bame <bame@debian.org>
Build-Depends: debhelper
Standards-Version: 3.1.1

Package: palo
Architecture: any
Depends: ${shlibs:Depends}
Description: Linux boot loader for parisc/hppa
 This package contains the parisc boot loader itself, plus palo which
 is the boot media management tool as lilo is for i386.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=2

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	

	touch configure-stamp

build: configure-stamp build-stamp
build-stamp:
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)
	#/usr/bin/docbook-to-man debian/palo.sgml > palo.1

	touch build-stamp

clean:
	# If we are on an hppa platform we need to regenerate iplboot
	# here.  Do it now so it is available for the source pkg build.
	@if [ `dpkg --print-architecture` = hppa ]; \
	then \
		echo "Regenerating iplboot"; \
		$(MAKE) realclean; \
		$(MAKE) iplboot; \
	else \
		echo "Leaving iplboot inplace as not packaging for hppa"; \
	fi

	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	-$(MAKE) clean

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/palo.
	$(MAKE) install DESTDIR=`pwd`/debian/palo


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
#	dh_testversion
	dh_testdir
	dh_testroot
#	dh_installdebconf	
	dh_installdocs
#	dh_installexamples
#	dh_installmenu
#	dh_installemacsen
#	dh_installpam
#	dh_installinit
#	dh_installcron
#	dh_installmanpages
#	dh_installinfo
#	dh_undocumented
#	dh_installchangelogs Changes
#	dh_link
	dh_strip
#	dh_compress
	dh_fixperms
	# You may want to make some executables suid here.
#	dh_suidregister
#	dh_makeshlibs
	dh_installdeb
#	dh_perl
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## palo 1.5

=== Makefile ===
--- 
+++ 
@@ -120,3 +120,10 @@
 	${INSTALL} -m444 README.html README changelog.gz \
 			${DESTDIR}/usr/share/doc/palo
 	${INSTALL} -m444 palo.8.gz ${DESTDIR}/usr/share/man/man8
+
+uninstall: 
+	${RM} -rf ${DESTDIR}/usr/share/doc/palo
+	${RM} -rf ${DESTDIR}/sbin/palo
+	${RM} -rf ${DESTDIR}/usr/share/palo
+	${RM} -rf ${DESTDIR}/usr/share/man/man8/palo.8.gz
+

=== ipl/Makefile ===
CFILES=\
	byteio.c      elf64.c	    ipl.c	  offset.c      \
	diskpart.c    ext2.c	    lib.c	  pdc_bootio.c  vsprintf.c \
	elf32.c	      fileio.c	    load.c	  pdc_cons.c	pdc_misc.c

OFILES=$(CFILES:.c=.o)

INCLUDES=bootloader.h common.h load.h

###############{

MACHINE	:= $(subst 64,,$(shell uname -m))

ifneq (${MACHINE},parisc)
# cross compilation
CC	= hppa-linux-gcc
LD	= hppa-linux-ld
AR	= hppa-linux-ar
endif

# Source sharing with palo
VPATH=../lib:.

CFLAGS	= -I. -I../lib -I../include -O2 -fwritable-strings -mdisable-fpregs -Wall
LDFLAGS  = -N --section-start .init=0x60000 -e '$$START$$'

all:	iplelf

iplelf:	crt0.o ipl.a
	echo "char *bld_info = \"`whoami`@`hostname` `date`\";" > build.c
	$(CC) $(CFLAGS) -c -o build.o build.c
	-rm -f build.c
	$(LD) $(LDFLAGS) -o iplelf crt0.o ipl.a build.o `$(CC) -print-libgcc-file-name`

ipl.a:	$(OFILES)
	$(AR) rv ipl.a $?

clean:
	rm -f iplelf *.o *.a

distclean: clean


.S.o:
	$(CC) -D__ASSEMBLY__ $(AFLAGS) -traditional -c -o $*.o $<

###############}

byteio.o \
ext2.o \
fileio.o \
lib.o \
offset.o \
pdc_bootio.o \
pdc_cons.o \
vsprintf.o :		bootloader.h

ipl.o :		bootloader.h load.h

diskpart.o :		common.h

elf32.o \
elf64.o \
load.o \
som.o :		common.h load.h

=== debian/changelog ===
palo (1.5) unstable; urgency=low

  * Some cleanups and error checking especially in ipl.c
  * Heisenbug (overwriting a buffer) found
  * Added an 'l' command for list kernel directory (jejb)
  * Accept both \b and \0177 as the interactive erase character (jejb)
  * Be sure to restart interactively after more failures (Joel)

 -- Paul Bame <bame@ldl.fc.hp.com>  Wed, 14 May 2004 09:00:29 -0600

palo (1.4) unstable; urgency=low

  * increase interactive command line size from 127 to 259 bytes
  * add more robust 'strcat' checking
  * add interactive 'r' command to reset command line to initial state

 -- Paul Bame <bame@debian.org>  Thu, 25 Mar 2004 13:01:23 -0700

palo (1.3) unstable; urgency=low

  * Add ability to format palo partition as ext3 (James Bottomley)
  * Make iplboot restart if it encounters and error (James Bottomley)
  * Detect and boot properly via serial mux (Ryan Bradetich)

 -- Paul Bame <bame@debian.org>  Tue, 14 Jan 2003 13:06:45 -0700

palo (1.2) unstable; urgency=low

  * Recognize RAID partition types (Martin K. Petersen)

 -- Paul Bame <bame@debian.org>  Tue, 14 Jan 2003 13:06:45 -0700

palo (1.1) unstable; urgency=low

  * Changed argument checking in palo.c
    Originally you could specify a kernel command line of up to 255
    characters, but in reality the firstblock structure could only
    hold 127. The check in palo.c has been changed to 127.

  * These changes relate to:
        - Build palo without kernel header source

    Removed conditional header includes depending on kernel version
    Removed the include for fs.h since we don't really need it.
        - ./ipl/ext2.c

    Removed the include for time.h since we don't really need it.
        - ./ipl/ipl.c

    Added ./include/asm and ./include/linux/byteorder to accomodate
    for all the new asm/* and linux/byteorder/* header files that
    were required to build palo without kernel headers.

  * Changes in this update done by Carlos O'Donell

 -- Paul Bame <bame@debian.org>  Tue,  6 Aug 2002 08:47:57 -0600

=== debian/control ===
Source: palo
Section: base
Priority: optional
Maintainer: Paul Bame <bame@debian.org>
Build-Depends: debhelper (>= 4)
Standards-Version: 3.6.1.0

Package: palo
Architecture: any
Depends: ${shlibs:Depends}
Suggests: e2fsprogs
Description: Linux boot loader for parisc/hppa
 This package contains the parisc boot loader itself, plus palo which
 is the boot media management tool as lilo is for i386.

=== debian/rules ===
--- 
+++ 
@@ -3,10 +3,10 @@
 # GNU copyright 1997 to 1999 by Joey Hess.
 
 # Uncomment this to turn on verbose mode.
-export DH_VERBOSE=1
+# export DH_VERBOSE=1
 
 # This is the debhelper compatability version to use.
-export DH_COMPAT=2
+export DH_COMPAT=4
 
 configure: configure-stamp
 configure-stamp:

## palo 1.6

=== debian/changelog ===
palo (1.6) unstable; urgency=low

  * some fail/restart changes didn't make it in 1.5 by mistake

 -- Paul Bame <bame@debian.org>  Tue, 21 Sep 2004 15:11:00 -0600

## palo 1.9

=== debian/changelog ===
palo (1.9) unstable; urgency=low

  * linux-kernel-headers is about to change which broke the palo
    build, so removed lots of dependencies on copies and references
    to linux header files, but added a dep on linux-kernel-headers.
  * handled a couple of lintian complaints

 -- Paul Bame <bame@fc.hp.com>  Wed, 20 Jul 2005 12:31:06 -0600

palo (1.8) unstable; urgency=low

  * remove -fwritable-strings from palo/ipl Makefile since gcc will
    eliminate it before long.

 -- Paul Bame <bame@debian.org>  Mon, 23 May 2005 10:53:46 -0600

palo (1.7) unstable; urgency=low

  * on updates, was reporting "doing a format as ext1".
    Fixed the message and improved the error handling.

 -- Grant Grundler <grundler@parisc-linux.org>  Fri, 28 Jan 2005 12:00:00 -0800

=== debian/control ===
Source: palo
Section: base
Priority: optional
Maintainer: Paul Bame <bame@debian.org>
Build-Depends: debhelper (>= 4), linux-kernel-headers (>= 2.6)
Standards-Version: 3.6.1.0

Package: palo
Architecture: any
Depends: ${shlibs:Depends}
Suggests: e2fsprogs (>= 1.2)
Description: Linux boot loader for parisc/hppa
 This package contains the parisc boot loader itself, plus palo which
 is the boot media management tool as lilo is for i386.

## palo 1.13

=== debian/changelog ===
palo (1.13) unstable; urgency=low

  * One more workaround for linux-kernel-headers differences: __swab64
    shows up on 64-bit machines on ubuntu.
  * 64-bit pointer casting fixes.

 -- LaMont Jones <lamont@debian.org>  Thu,  5 Jan 2006 10:08:58 -0700

palo (1.12) unstable; urgency=low

  * Work around differences in linux-kernel-headers between
    Debian and Ubuntu. Test built on sid and dapper on hppa, and
    sid/i386.
  * Use userspace sanitized ext2_fs.h file from e2fsprogs, note, we still
    need to include some kernel headers for per-arch types and endian
    conversions.

 -- Kyle McMartin <kyle@debian.org>  Mon,  2 Jan 2006 12:16:36 -0500

palo (1.11) unstable; urgency=low

  * Flush Instruction Cache insn now requires space register to be
    specified. Previously it would assume %sr0.
  * Fix include of ext2_fs.h by stubbing out some definitions it
    requires. Patch from Richard Hirst. (closes: #336346)
  * Fix FTBFS from previous version a different way. Checked that it
    properly works on i386 and hppa. Patch from Andreas Jochens.
    (closes: #320284)

 -- Kyle McMartin <kyle@debian.org>  Wed, 28 Dec 2005 14:46:44 -0500

palo (1.10) UNRELEASED; urgency=low

  * Fix FTBFS with Debian's linux-kernel-headers.  Closes: #320284
  * commandline overflow error was lacking arguments.

 -- LaMont Jones <lamont@debian.org>  Wed, 12 Oct 2005 10:41:00 -0600

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: palo
-Section: base
+Section: admin
 Priority: optional
 Maintainer: Paul Bame <bame@debian.org>
 Build-Depends: debhelper (>= 4), linux-kernel-headers (>= 2.6)

## palo 1.14

=== debian/changelog ===
palo (1.14) unstable; urgency=low

  [Helge Deller]
  * Make ELF32 and ELF64 loaders more similiar, other small fixups.
  * Fix build on SuSE 10.

  [Kyle McMartin]
  * Add LaMont and myself to Uploaders.

 -- Kyle McMartin <kyle@debian.org>  Sat,  8 Apr 2006 16:00:55 -0400

=== debian/control ===
--- 
+++ 
@@ -2,6 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Paul Bame <bame@debian.org>
+Uploaders: LaMont Jones <lamont@debian.org>, Kyle McMartin <kyle@debian.org>
 Build-Depends: debhelper (>= 4), linux-kernel-headers (>= 2.6)
 Standards-Version: 3.6.1.0

## palo 1.14ubuntu1

=== debian/changelog ===
palo (1.14ubuntu1) edgy; urgency=low

  * Build-dep on linux-libc-dev | linux-kernel-headers (>= 2.6), to allow
    for the package name change, so we can build on current edgy and beyond.

 -- Adam Conrad <adconrad@ubuntu.com>  Fri, 13 Oct 2006 21:11:15 +1000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Paul Bame <bame@debian.org>
 Uploaders: LaMont Jones <lamont@debian.org>, Kyle McMartin <kyle@debian.org>
-Build-Depends: debhelper (>= 4), linux-kernel-headers (>= 2.6)
+Build-Depends: debhelper (>= 4), linux-libc-dev | linux-kernel-headers (>= 2.6)
 Standards-Version: 3.6.1.0
 
 Package: palo

## palo 1.16build1

=== debian/changelog ===
palo (1.16build1) gutsy; urgency=low

  * ugly uploading hacks

 -- LaMont Jones <lamont@ubuntu.com>  Fri, 14 Sep 2007 12:04:20 -0600

palo (1.16) unstable; urgency=low

  [ Matthew Wilcox ]
  * Increase allowed size from 20MB to 800MB when creating lifimage files
    to be netbooted.

  [ LaMont Jones ]
  * Document git repository in source package.

 -- LaMont Jones <lamont@debian.org>  Wed, 12 Sep 2007 10:21:00 -0600

palo (1.15) unstable; urgency=low

  [ Kyle McMartin ]
  * Make the -U on an unformatted volume message slightly more helpful.

  [ Jeff Bailey ]
  * Drop dependancy on linux-kernel-headers, the new package
    linux-libc-dev is an indirect dependancy of build-essential.
  * Depend on debhelper >= 5, set compat file to 5.
  * Drop unneeded headers: asm/elf.h, asm/posix_types.h, asm/ptrace.h,
    asm/types.h, linux/elf.h.
  * ipl/ext2.c: No longer needs asm/byteorder.h, include linux/types.h
    after sys/stat.h to avoid compilation failure.
  * Makefile: Note why iplboot isn't cleaned.

 -- LaMont Jones <lamont@debian.org>  Tue, 11 Sep 2007 14:41:23 -0600

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,10 @@
 Priority: optional
 Maintainer: Paul Bame <bame@debian.org>
 Uploaders: LaMont Jones <lamont@debian.org>, Kyle McMartin <kyle@debian.org>
-Build-Depends: debhelper (>= 4), linux-libc-dev | linux-kernel-headers (>= 2.6)
+Build-Depends: debhelper (>= 5)
 Standards-Version: 3.6.1.0
+XS-Vcs-Browser: http://git.parisc-linux.org/git/palo.git
+XS-Vcs-Git: git://git.parisc-linux.org/git/palo.git
 
 Package: palo
 Architecture: any

## palo 1.16ubuntu1

=== Makefile ===
--- 
+++ 
@@ -83,6 +83,8 @@
 	./palo/mkbootable ipl/iplelf iplboot
 
 clean:
+	# We intentionally don't remove iplboot here so that the file
+	# is available for cross-installation.
 	rm -f lifimage palo.8.gz changelog.gz
 	cd ipl && make clean
 	cd palo && make clean

=== ipl/Makefile ===
--- 
+++ 
@@ -21,7 +21,7 @@
 # Source sharing with palo
 VPATH=../lib:.
 
-CFLAGS	= -I. -I../lib -I../include -O2 -fwritable-strings -mdisable-fpregs -Wall
+CFLAGS	= -I. -I../lib -I../include -O2 -mdisable-fpregs -Wall
 LDFLAGS  = -N --section-start .init=0x60000 -e '$$START$$'
 
 all:	iplelf

=== palo/Makefile ===
CFILES=\
	diskpart.c    elf64.c	    load.c	  paloio.c      \
	elf32.c	      error.c	    palo.c

OFILES=$(CFILES:.c=.o)


INCLUDES=common.h load.h palo.h

###############{

OS := $(shell uname -s)
CC=gcc
ifeq ($(strip ${OS}),HP-UX)
CFLAGS=-g -O -I../include -I../lib -I$(PA)/include
else
CFLAGS=-g -O -I../include -I../lib
endif

# LDFLAGS=-Wl,-Bstatic 
LDFLAGS=

OFILES2=mkbootable.o elf64.o load.o paloio.o elf32.o error.o

# Source sharing with ipl
VPATH=../lib:.

all:	palo mkbootable

palo:	palo.a
	echo "char *bld_info = \"`whoami`@`hostname` `date`\";" > build.c
	$(CC) $(CFLAGS) -c -o build.o build.c
	-rm -f build.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o palo palo.a build.o

palo.a:	$(OFILES)
	ar rv palo.a $?

mkbootable:	$(OFILES2)
	$(CC) $(CFLAGS) $(LDFLAGS) -o mkbootable $(OFILES2)

clean:
	rm -f palo mkbootable *.a *.o usage.h

distclean: clean

usage.h:	usage.txt
	sed 's/.*/"&\\n"/' < usage.txt > usage.h

###############}

diskpart.o :		common.h

elf32.o \
elf64.o \
load.o :		common.h load.h

som.o :		common.h load.h

palo.o :		load.h palo.h

paloio.o :		palo.h

error.o:	usage.h error.c

=== debian/changelog ===
palo (1.16ubuntu1) hardy; urgency=low

  * Include <sys/types.h> before <linux/elf.h>, to work around type
    issues in linux-libc-dev.  LP: #184216.
  * Modify Maintainer value to match the DebianMaintainerField
    specification.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 02 Apr 2008 08:24:17 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: palo
 Section: admin
 Priority: optional
-Maintainer: Paul Bame <bame@debian.org>
+Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Paul Bame <bame@debian.org>
 Uploaders: LaMont Jones <lamont@debian.org>, Kyle McMartin <kyle@debian.org>
 Build-Depends: debhelper (>= 5)
 Standards-Version: 3.6.1.0

## palo 1.16+nmu1

=== debian/changelog ===
palo (1.16+nmu1) unstable; urgency=medium

  * Non-maintainer upload.
  * lib/elf32.c, lib/elf64.c: include sys/types.h explicitly to work around
    a linux/elf.h that's not userspace-safe. Patch by Steve Langasek, thanks!
    (Closes: #464262)

 -- Adeodato Simó <dato@net.com.org.es>  Wed, 08 Oct 2008 16:41:10 +0200

## palo 1.16+nmu1ubuntu1

=== debian/changelog ===
palo (1.16+nmu1ubuntu1) jaunty; urgency=low

  * palo/palo.c: Supply a mode to open() to go with the O_CREAT flag (filed
    as Debian bug #506083).

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 18 Nov 2008 10:14:57 +0000

## palo 1.17

=== debian/changelog ===
palo (1.17) unstable; urgency=low

  [ Paul Bame ]
  * orphaning palo
  * WARNING!!! - the 1.16 Debian source diverged from the 1.16 palo
   git repository
 -- Paul Bame <bame@debian.org>  Sun, 07 Mar 2010 15:53:41 -0700

=== debian/rules ===
--- 
+++ 
@@ -5,8 +5,6 @@
 # Uncomment this to turn on verbose mode.
 # export DH_VERBOSE=1
 
-# This is the debhelper compatability version to use.
-export DH_COMPAT=4
 
 configure: configure-stamp
 configure-stamp:

## palo 1.18

=== debian/changelog ===
palo (1.18) unstable; urgency=low

  * QA upload.
  * Merge from Ubuntu:
    - palo/palo.c: Supply a mode to open() to go with the O_CREAT flag
      (closes: #506083).

 -- Colin Watson <cjwatson@debian.org>  Sat, 02 Oct 2010 10:54:45 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: palo
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Paul Bame <bame@debian.org>
-Uploaders: LaMont Jones <lamont@debian.org>, Kyle McMartin <kyle@debian.org>
+Maintainer: Debian QA Group <packages@qa.debian.org>
+Uploaders: 
 Build-Depends: debhelper (>= 5)
 Standards-Version: 3.6.1.0
 XS-Vcs-Browser: http://git.parisc-linux.org/git/palo.git

## palo 1.95

=== ipl/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 CFILES=\
-	byteio.c      elf64.c	    ipl.c	  offset.c      \
+	byteio.c      elf64.c	    ipl.c	  offset.c      gzip.c \
 	diskpart.c    ext2.c	    lib.c	  pdc_bootio.c  vsprintf.c \
 	elf32.c	      fileio.c	    load.c	  pdc_cons.c	pdc_misc.c
 
@@ -9,19 +9,32 @@
 
 ###############{
 
-MACHINE	:= $(subst 64,,$(shell uname -m))
+# cc-cross-prefix
+# Usage: CROSS_COMPILE := $(call cc-cross-prefix, m68k-linux-gnu- m68k-linux-)
+# Return first prefix where a prefix$(CC) is found in PATH.
+# If no $(CC) found in PATH with listed prefixes return nothing
+cc-cross-prefix =  \
+	$(word 1, $(foreach c,$(1),                                   \
+		$(shell set -e;                                       \
+		if (which $(strip $(c))gcc) > /dev/null 2>&1 ; then   \
+			echo $(c);                                    \
+		fi)))
 
-ifneq (${MACHINE},parisc)
 # cross compilation
-CC	= hppa-linux-gcc
-LD	= hppa-linux-ld
-AR	= hppa-linux-ar
-endif
+CC_ARCHES = hppa hppa1.1
+CC_SUFFIXES = linux linux-gnu unknown-linux-gnu
+CROSS_COMPILE := $(call cc-cross-prefix, \
+	$(foreach a,$(CC_ARCHES), \
+	$(foreach s,$(CC_SUFFIXES),$(a)-$(s)-)))
+
+CC	= ${CROSS_COMPILE}gcc
+AR	= ar
+LD	= ld
 
 # Source sharing with palo
 VPATH=../lib:.
 
-CFLAGS	= -I. -I../lib -I../include -O2 -mdisable-fpregs -Wall
+CFLAGS	= -DIPL_LOADER -I. -I../lib -I../include -O2 -mdisable-fpregs -Wall
 LDFLAGS  = -N --section-start .init=0x60000 -e '$$START$$'
 
 all:	iplelf

=== palo/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 CFILES=\
 	diskpart.c    elf64.c	    load.c	  paloio.c      \
-	elf32.c	      error.c	    palo.c
+	elf32.c	      error.c	    gzip.c	  palo.c
 
 OFILES=$(CFILES:.c=.o)
 
@@ -10,17 +10,17 @@
 ###############{
 
 OS := $(shell uname -s)
-CC=gcc
+CC?=cc
 ifeq ($(strip ${OS}),HP-UX)
 CFLAGS=-g -O -I../include -I../lib -I$(PA)/include
 else
-CFLAGS=-g -O -I../include -I../lib
+CFLAGS=-g -O -I../include -I../lib -D_FILE_OFFSET_BITS=64
 endif
 
 # LDFLAGS=-Wl,-Bstatic 
 LDFLAGS=
 
-OFILES2=mkbootable.o elf64.o load.o paloio.o elf32.o error.o
+OFILES2=mkbootable.o elf64.o load.o paloio.o elf32.o error.o gzip.o
 
 # Source sharing with ipl
 VPATH=../lib:.

=== debian/changelog ===
palo (1.95) unstable; urgency=medium

  * Re-add build dependency on lynx, generate README from
    README.html again. Fixes FTBFS on hppa.
  * Update pre-built iplboot bootloader code.

 -- Helge Deller <deller@gmx.de>  Sun, 06 Apr 2014 13:12:44 -0600

palo (1.94) unstable; urgency=medium

  [ Helge Deller ]
  * Fix build on non-Linux kernels.
  * Provide possibility to configure used MAKE tool via environment
    variable. Since palo requires GNU make, this gives an option to
    set MAKE=gnumake on HP-UX.
  * Disable getopt library on HP-UX.
  * Do not hardcode gcc compiler in Makefile, e.g. on HP-UX
    aCC can be used.
  * Use printf("0x%08x") instead of printf("%p"), which is not
    supported on HP-UX.
  * Provide endianess byteswapping functions for HP-UX.
  * Provide pre-built README file to avoid dependency on lynx.

  [ John Paul Adrian Glaubitz ]
  * Remove boiler plate comment and fix wording in debian/rules.

 -- Helge Deller <deller@gmx.de>  Sat, 05 Apr 2014 11:31:51 +0200

palo (1.93) unstable; urgency=medium

  [Helge Deller]
  * Reintroduce package to Debian. (Closes: #742068)

  [John Paul Adrian Glaubitz]
  * Clean up debian/changelog.
  * Clean up debian/README.Debian.
  * Add debian/README.source to explain the version
    history of the PALO sources in Debian.
  * Bump debhelper level to 9.
  * Use dh to streamline debian/rules.
  * Remove usr/bin and usr/sbin from debian/dirs, they are empty.
  * Update debian/copyright to copyright format 1.0.

 -- Helge Deller <deller@gmx.de>  Tue, 18 Mar 2014 13:47:42 -0600

palo (1.92) unstable; urgency=low

  * Increase possible command line length from 127 to 1024 bytes.
  * Each kernel parameter can hold up to 200 chars (79 before).
  * Various smaller bugfixes.

 -- Helge Deller <deller@gmx.de>  Wed, 09 Oct 2013 17:47:54 +0200

palo (1.91) unstable; urgency=low

  * Add spec-file for RPM.
  * Remove debug infos.
  * Add overflow checks.

 -- Helge Deller <deller@gmx.de>  Sat, 06 Jul 2013 22:08:05 +0200

palo (1.90) unstable; urgency=low

  * New maintainer.
  * Add support for gzip-compressed kernel images.
  * Add boot menu option "x" to reset/reboot the machine.
  * Lots of other small bug fixes.

 -- Helge Deller <deller@gmx.de>  Tue, 02 Jul 2013 21:22:36 +0200

palo (1.16) UNRELEASED; urgency=low

  [Matthew Wilcox]
  * Increase allowed size from 20MB to 800MB when creating lifimage files
    for booting over the network.

  [ Kyle McMartin ]
  * Fix FTBFS on ia64: Useful macros were undefined in userspace.

 -- Kyle McMartin <kyle@debian.org>  Mon, 26 Nov 2007 17:09:38 -0500

=== debian/control ===
Source: palo
Section: admin
Priority: optional
Maintainer: Helge Deller <deller@gmx.de>
Uploaders:
Build-Depends: debhelper (>= 9), lynx
Standards-Version: 3.9.5
Homepage: http://git.kernel.org/cgit/linux/kernel/git/deller/palo.git
Vcs-Browser: http://git.kernel.org/cgit/linux/kernel/git/deller/palo.git
Vcs-Git: git://git.kernel.org/pub/scm/linux/kernel/git/deller/palo.git

Package: palo
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: e2fsprogs (>= 1.2)
Description: Linux boot loader for HP PA-RISC
 PALO is the boot loader for HP PA-RISC machines. This package contains
 both the actual boot loader called iplboot as well as a boot media
 management tool after which bears the name PALO. While iplboot
 can be used on PA-RISC machines only, the PALO media management tool
 runs on any architecture and is used to create boot media for
 HP PA-RISC machines.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

override_dh_auto_clean:
	# The palo package source ships with the iplboot binary
	# pre-built and regenerates it from hppa assembly code
	# when building on hppa machines only. This way, palo
	# can also be built on non-hppa build hosts without
	# problems using the pre-built iplboot binary.
	@if [ `dpkg --print-architecture` = hppa ]; \
	 then \
		echo "Regenerating iplboot."; \
		$(MAKE) realclean; \
		$(MAKE) iplboot; \
	 else \
		echo "Leaving iplboot in place since we're not building on hppa."; \
	 fi

%:
	dh $@

## palo 1.96

=== ipl/Makefile ===
--- 
+++ 
@@ -6,8 +6,6 @@
 OFILES=$(CFILES:.c=.o)
 
 INCLUDES=bootloader.h common.h load.h
-
-###############{
 
 # cc-cross-prefix
 # Usage: CROSS_COMPILE := $(call cc-cross-prefix, m68k-linux-gnu- m68k-linux-)
@@ -31,16 +29,22 @@
 AR	= ar
 LD	= ld
 
+ifneq ("$(wildcard /etc/debian_version)","")
+BLDINFO := $(shell echo http://www.parisc-linux.org - `dpkg-parsechangelog -l../debian/changelog -SDate`)
+else
+BLDINFO := $(shell echo http://www.parisc-linux.org - `LC_TIME=C date`)
+endif
+
 # Source sharing with palo
 VPATH=../lib:.
 
-CFLAGS	= -DIPL_LOADER -I. -I../lib -I../include -O2 -mdisable-fpregs -Wall
+CFLAGS	= -DIPL_LOADER -I. -I../lib -I../include -O2 -mdisable-fpregs -Wall -fno-delete-null-pointer-checks
 LDFLAGS  = -N --section-start .init=0x60000 -e '$$START$$'
 
 all:	iplelf
 
 iplelf:	crt0.o ipl.a
-	echo "char *bld_info = \"`whoami`@`hostname` `date`\";" > build.c
+	echo "const char bld_info[] = \"$(BLDINFO)\";" > build.c
 	$(CC) $(CFLAGS) -c -o build.o build.c
 	-rm -f build.c
 	$(LD) $(LDFLAGS) -o iplelf crt0.o ipl.a build.o `$(CC) -print-libgcc-file-name`
@@ -56,8 +60,6 @@
 
 .S.o:
 	$(CC) -D__ASSEMBLY__ $(AFLAGS) -traditional -c -o $*.o $<
-
-###############}
 
 byteio.o \
 ext2.o \

=== debian/changelog ===
palo (1.96) unstable; urgency=medium

  * Make the build reproducible. (Closes: #778437)
  * Unbreak loading Linux kernels bigger than 16 MB.
  * Enable support for gcc-6.

 -- Helge Deller <deller@gmx.de>  Sun, 08 Oct 2016 22:40:31 +0100

## palo 1.97

=== ipl/Makefile ===
--- 
+++ 
@@ -27,7 +27,7 @@
 
 CC	= ${CROSS_COMPILE}gcc
 AR	= ar
-LD	= ld
+LD	= ${CROSS_COMPILE}ld
 
 ifneq ("$(wildcard /etc/debian_version)","")
 BLDINFO := $(shell echo http://www.parisc-linux.org - `dpkg-parsechangelog -l../debian/changelog -SDate`)

=== palo/Makefile ===
--- 
+++ 
@@ -7,14 +7,18 @@
 
 INCLUDES=common.h load.h palo.h
 
-###############{
-
 OS := $(shell uname -s)
 CC?=cc
 ifeq ($(strip ${OS}),HP-UX)
 CFLAGS=-g -O -I../include -I../lib -I$(PA)/include
 else
 CFLAGS=-g -O -I../include -I../lib -D_FILE_OFFSET_BITS=64
+endif
+
+ifneq ("$(wildcard /etc/debian_version)","")
+BLDINFO := $(shell echo http://www.parisc-linux.org - `dpkg-parsechangelog -l../debian/changelog -SDate`)
+else
+BLDINFO := $(shell echo http://www.parisc-linux.org - `LC_TIME=C date`)
 endif
 
 # LDFLAGS=-Wl,-Bstatic 
@@ -28,7 +32,7 @@
 all:	palo mkbootable
 
 palo:	palo.a
-	echo "char *bld_info = \"`whoami`@`hostname` `date`\";" > build.c
+	echo "const char bld_info[] = \"$(BLDINFO)\";" > build.c
 	$(CC) $(CFLAGS) -c -o build.o build.c
 	-rm -f build.c
 	$(CC) $(CFLAGS) $(LDFLAGS) -o palo palo.a build.o

=== debian/changelog ===
palo (1.97) unstable; urgency=medium

  * Enable support for cross-building of iplboot: (Closes: #851792)
    [ Helge Deller ]
    - Add gcc-hppa-linux-gnu and libc6-dev-hppa-cross to
      Build-Depends on architectures other than hppa.
    - Modify ipl/Makefile to support cross-compiling.
    [ John Paul Adrian Glaubitz ]
    - Build palo on amd64, i386, hppa and x32 only.
    - Stop shipping pre-compiled iplboot in source tree.
    - Move building of iplboot from dh_auto_clean to dh_auto_build.

 -- Helge Deller <deller@gmx.de>  Thu, 26 Jan 2017 14:48:37 +0100

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

override_dh_auto_build:
	echo "Regenerating iplboot."
	$(MAKE) realclean
	$(MAKE) iplboot
	dh_auto_build
%:
	dh $@

## palo 2.00

=== Makefile ===
--- 
+++ 
@@ -20,6 +20,9 @@
 
 export PA
 
+# GNU make is needed, can be overridden by environment, e.g. for HP-UX
+MAKE ?= make
+
 # Choose at most one of RAMDISK or NFSROOT below
 #
 # Set RAMDISK to a ramdisk image to in order to load the ramdisk on the
@@ -35,6 +38,8 @@
 # do that and I'm not sure the kernel's very good at it right now either.
 #
 NFSROOT = 10.10.10.2
+# NFSROOT = 10.10.10.2:/tftpboot/nfsroot
+
 
 ROOT=root=/dev/sda1
 
@@ -64,10 +69,10 @@
 	lynx -dump README.html > README
 
 makepalo:
-	cd palo && make
+	cd palo && $(MAKE)
 
 makeipl:
-	cd ipl && make
+	cd ipl && $(MAKE)
 
 lifimage:	all Makefile lifimage-only
 
@@ -85,19 +90,19 @@
 clean:
 	# We intentionally don't remove iplboot here so that the file
 	# is available for cross-installation.
-	rm -f lifimage palo.8.gz changelog.gz
-	cd ipl && make clean
-	cd palo && make clean
+	rm -f lifimage palo.8.gz changelog.gz palo.tgz
+	cd ipl && $(MAKE) clean
+	cd palo && $(MAKE) clean
 
 realclean:
-	rm -f iplboot lifimage palo.8.gz changelog.gz
-	cd ipl && make clean
-	cd palo && make clean
+	rm -f iplboot lifimage palo.8.gz changelog.gz README palo.tgz
+	cd ipl && $(MAKE) clean
+	cd palo && $(MAKE) clean
 
 distclean:
-	rm -f lifimage palo.8.gz changelog.gz
-	cd ipl && make distclean
-	cd palo && make distclean
+	rm -f lifimage palo.8.gz changelog.gz README palo.tgz
+	cd ipl && $(MAKE) distclean
+	cd palo && $(MAKE) distclean
 
 palo.8.gz:	palo.8
 	gzip -9 < palo.8 > palo.8.gz
@@ -129,3 +134,10 @@
 	${RM} -rf ${DESTDIR}/usr/share/palo
 	${RM} -rf ${DESTDIR}/usr/share/man/man8/palo.8.gz
 
+palo.tgz:
+	tar cvfz palo.tgz *
+
+# Build RPM source and binary package
+palo.rpm:
+	rm -f palo.tgz && $(MAKE) palo.tgz && rpmbuild -ta palo.tgz
+

=== ipl/Makefile ===
--- 
+++ 
@@ -38,6 +38,7 @@
 # Source sharing with palo
 VPATH=../lib:.
 
+AFLAGS	= -I../lib
 CFLAGS	= -DIPL_LOADER -I. -I../lib -I../include -O2 -mdisable-fpregs -Wall -fno-delete-null-pointer-checks
 LDFLAGS  = -N --section-start .init=0x60000 -e '$$START$$'

=== palo/Makefile ===
--- 
+++ 
@@ -38,7 +38,7 @@
 	$(CC) $(CFLAGS) $(LDFLAGS) -o palo palo.a build.o
 
 palo.a:	$(OFILES)
-	ar rv palo.a $?
+	$(AR) rv palo.a $?
 
 mkbootable:	$(OFILES2)
 	$(CC) $(CFLAGS) $(LDFLAGS) -o mkbootable $(OFILES2)

=== debian/changelog ===
palo (2.00) unstable; urgency=medium

  [ Helge Deller ]
  * Default to console=ttyS0 on all machines (incl. rp34x0).
  * Fix layout when printing partition table with discs > 100GB.
  * Fix up boot messages with regard to newline behaviour.
  * Include palo version identifier in binary ipl code.

  [ Rolf Eike Beer ]
  * Allow to override ar.

 -- Helge Deller <deller@gmx.de>  Mon, 01 Jan 2018 21:07:58 +0100

palo (1.99) unstable; urgency=medium

  * Increase loadable kernel size to 100MB.
  * Improve debug output and error handling.
  * Add hidden "d" command to toggle debug mode in interactive mode.

 -- Helge Deller <deller@gmx.de>  Fri, 18 Aug 2017 11:50:44 +0200

palo (1.98) unstable; urgency=medium

  * Default to console=ttyS1 on rp34x0 machines.

 -- Helge Deller <deller@gmx.de>  Tue, 30 May 2017 13:12:20 -0700

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,14 @@
 Priority: optional
 Maintainer: Helge Deller <deller@gmx.de>
 Uploaders:
-Build-Depends: debhelper (>= 9), lynx
+Build-Depends: debhelper (>= 9), lynx, gcc-hppa-linux-gnu [!hppa], libc6-dev-hppa-cross [!hppa]
 Standards-Version: 3.9.5
 Homepage: http://git.kernel.org/cgit/linux/kernel/git/deller/palo.git
 Vcs-Browser: http://git.kernel.org/cgit/linux/kernel/git/deller/palo.git
 Vcs-Git: git://git.kernel.org/pub/scm/linux/kernel/git/deller/palo.git
 
 Package: palo
-Architecture: any
+Architecture: amd64 i386 hppa x32
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Suggests: e2fsprogs (>= 1.2)
 Description: Linux boot loader for HP PA-RISC

## palo 2.11

=== Makefile ===
--- 
+++ 
@@ -63,8 +63,10 @@
 
 CMDLINE = 0/vmlinux HOME=/ TERM=linux $(ROOT) $(EISAIRQ) $(CONSOLE)
 
+HELP2MAN := $(shell command -v help2man 2> /dev/null)
+
 all: makepalo README palo.conf
-	
+
 README:	README.html
 	lynx -dump README.html > README
 
@@ -104,6 +106,11 @@
 	cd ipl && $(MAKE) distclean
 	cd palo && $(MAKE) distclean
 
+ifdef HELP2MAN
+palo.8:		palo/palo palo/usage.txt palo.help2man
+	help2man --no-info -i palo.help2man ./palo/palo > palo.8
+endif
+
 palo.8.gz:	palo.8
 	gzip -9 < palo.8 > palo.8.gz

=== debian/changelog ===
palo (2.11) unstable; urgency=medium

  [ James Bottomley ]
  * Fix loading of compressed kernels by reducing .bss usage

 -- Helge Deller <deller@gmx.de>  Wed, 31 Jul 2019 09:39:23 +0200

palo (2.10) unstable; urgency=medium

  [ James Bottomley ]
  * Update palo documentation
  * palo: place iplboot inside disk label if it's big enough
  * palo: add support for formatting as ext4
  * iplboot: add ext4 support

 -- Helge Deller <deller@gmx.de>  Sun, 21 Jul 2019 19:06:09 +0200

palo (2.01) unstable; urgency=medium

  [ Helge Deller ]
  * Recommend instead of suggest e2fsprogs in debian control file.
    (Closes: #887258)
  * Wire up help2man to create better man page (suggested by
    Andreas Henriksson <andreas@fatal.se>)
  * fix sprintf out-of-bounds check in iplboot code

  [ James Bottomley ]
  * fix IPL overlap with ext2/ext3 resize_inode

 -- Helge Deller <deller@gmx.de>  Wed, 17 Jan 2018 15:15:40 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Helge Deller <deller@gmx.de>
 Uploaders:
-Build-Depends: debhelper (>= 9), lynx, gcc-hppa-linux-gnu [!hppa], libc6-dev-hppa-cross [!hppa]
+Build-Depends: debhelper (>= 9), lynx, gcc-hppa-linux-gnu [!hppa], libc6-dev-hppa-cross [!hppa], help2man
 Standards-Version: 3.9.5
 Homepage: http://git.kernel.org/cgit/linux/kernel/git/deller/palo.git
 Vcs-Browser: http://git.kernel.org/cgit/linux/kernel/git/deller/palo.git
@@ -12,7 +12,7 @@
 Package: palo
 Architecture: amd64 i386 hppa x32
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Suggests: e2fsprogs (>= 1.2)
+Recommends: e2fsprogs
 Description: Linux boot loader for HP PA-RISC
  PALO is the boot loader for HP PA-RISC machines. This package contains
  both the actual boot loader called iplboot as well as a boot media

## palo 2.12

=== Makefile ===
--- 
+++ 
@@ -145,6 +145,6 @@
 	tar cvfz palo.tgz *
 
 # Build RPM source and binary package
-palo.rpm:
+palo.rpm rpm:
 	rm -f palo.tgz && $(MAKE) palo.tgz && rpmbuild -ta palo.tgz

=== debian/changelog ===
palo (2.12) unstable; urgency=medium

  [ James Bottomley ]
  * ext2: fix ext4 group cache

  [ Helge Deller ]
  * Update Standards-Version to 4.4.0, no changes required
  * Various code cleanups, pdc.h sync, add rpm build target
  * Update README file

 -- Helge Deller <deller@gmx.de>  Tue, 10 Sep 2019 12:01:26 +0200

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,9 @@
 Maintainer: Helge Deller <deller@gmx.de>
 Uploaders:
 Build-Depends: debhelper (>= 9), lynx, gcc-hppa-linux-gnu [!hppa], libc6-dev-hppa-cross [!hppa], help2man
-Standards-Version: 3.9.5
-Homepage: http://git.kernel.org/cgit/linux/kernel/git/deller/palo.git
-Vcs-Browser: http://git.kernel.org/cgit/linux/kernel/git/deller/palo.git
+Standards-Version: 4.4.0
+Homepage: https://git.kernel.org/cgit/linux/kernel/git/deller/palo.git
+Vcs-Browser: https://git.kernel.org/cgit/linux/kernel/git/deller/palo.git
 Vcs-Git: git://git.kernel.org/pub/scm/linux/kernel/git/deller/palo.git
 
 Package: palo

=== debian/rules ===
--- 
+++ 
@@ -9,5 +9,6 @@
 	$(MAKE) realclean
 	$(MAKE) iplboot
 	dh_auto_build
+
 %:
 	dh $@

## palo 2.14

=== debian/changelog ===
palo (2.14) unstable; urgency=medium

  [ Helge Deller ]
  * Switch to debhelper version 13
  * Improve palo man page
  * Update PARISC Linux homepage
  * Update Standards-Version to 4.5.0, no changes required

 -- Helge Deller <deller@gmx.de>  Sat, 30 May 2020 22:20:30 +0000

palo (2.13) unstable; urgency=medium

  [ Helge Deller ]
  * ipl: Reduce ext4 debug output
  * rpm: Fix building rpm package on Fedora 30 via "make rpm"
  * Update Standards-Version to 4.4.1, no changes required

  [ Jeroen Roovers ]
  * ipl: Ensure no GCC builtins replace string functions

 -- Helge Deller <deller@gmx.de>  Wed, 20 May 2020 19:35:50 +0000

## palo 2.15

=== Makefile ===
--- 
+++ 
@@ -107,8 +107,10 @@
 	cd palo && $(MAKE) distclean
 
 ifdef HELP2MAN
-palo.8:		palo/palo palo/usage.txt palo.help2man
-	help2man --no-info -i palo.help2man ./palo/palo > palo.8
+palo.8:		makepalo palo/usage.txt palo.help2man
+	help2man --section=8 --no-info \
+		--name="boot media management tool for PA-RISC/HPPA." \
+		--include=palo.help2man ./palo/palo > palo.8
 endif
 
 palo.8.gz:	palo.8

=== ipl/Makefile ===
--- 
+++ 
@@ -30,16 +30,16 @@
 LD	= ${CROSS_COMPILE}ld
 
 ifneq ("$(wildcard /etc/debian_version)","")
-BLDINFO := $(shell echo http://www.parisc-linux.org - `dpkg-parsechangelog -l../debian/changelog -SDate`)
+BLDINFO := $(shell echo https://parisc.wiki.kernel.org - `dpkg-parsechangelog -l../debian/changelog -SDate`)
 else
-BLDINFO := $(shell echo http://www.parisc-linux.org - `LC_TIME=C date`)
+BLDINFO := $(shell echo https://parisc.wiki.kernel.org - `LC_TIME=C date`)
 endif
 
 # Source sharing with palo
 VPATH=../lib:.
 
 AFLAGS	= -I../lib
-CFLAGS	= -DIPL_LOADER -I. -I../lib -I../include -O2 -mdisable-fpregs -Wall -fno-delete-null-pointer-checks
+CFLAGS	= -DIPL_LOADER -I. -I../lib -I../include -O2 -mdisable-fpregs -Wall -fno-delete-null-pointer-checks -fno-builtin
 LDFLAGS  = -N --section-start .init=0x60000 -e '$$START$$'
 
 all:	iplelf

=== palo/Makefile ===
--- 
+++ 
@@ -16,9 +16,9 @@
 endif
 
 ifneq ("$(wildcard /etc/debian_version)","")
-BLDINFO := $(shell echo http://www.parisc-linux.org - `dpkg-parsechangelog -l../debian/changelog -SDate`)
+BLDINFO := $(shell echo https://parisc.wiki.kernel.org - `dpkg-parsechangelog -l../debian/changelog -SDate`)
 else
-BLDINFO := $(shell echo http://www.parisc-linux.org - `LC_TIME=C date`)
+BLDINFO := $(shell echo https://parisc.wiki.kernel.org - `LC_TIME=C date`)
 endif
 
 # LDFLAGS=-Wl,-Bstatic

=== debian/changelog ===
palo (2.15) unstable; urgency=medium

  [ James Bottomley ]
  * Remove useless files from directory listing

  [ Helge Deller ]
  * Add "m" option to enable manufacturing mode on C8000

 -- Helge Deller <deller@gmx.de>  Sat, 30 Jan 2021 11:37:58 +0000
